I didn't have much time as I was bogged down wih contract work but I really wanted to atleast do some sort of preview. The idea was to keep the user in context when checking out. Since checkout and "finalize weren't too different, why not just have the ui tweak itself on the same screen. (At the momeent of writing this my trash cans are still visible in the finalize portion of the UI). I had the checkout button change color on finalize to draw the users attention. Maybe should have made it get larger too? I also wanted to keep UI to minimum on the screen. So I only show things when they are needed. The cancel button only shows itself when there is a need for it. The cancel button has a less in your face look. This is to discourage the user from wanting to press it(We may not want this. Should talk to product). This was taken from Facebook and many other apps. The primary button is easily readable because of the color pop and look. The textbuttons are a little harder to perceive. A couple of years ago Facebook became everyone's default messaging app from doing this. I'm not sure if the "+" button is noticicable enough for the user to press to add the item back. I figured this was reinforced by the trashcan being there first. I asked my wife to do it and she didn't have a problem seeing it. I try to use icons instead of words since the mind can perceive and understand images faster than the cognitive load of reading. https://www.easel.ly/blog/text-vs-images-which-content-format-effective/
The details screen is plain to me but that was an after thought because I wanted the checkout process to be slick first. I went to Louis Vuitton's website to see their layout for selling items and just took from that. If more time I would have done a cell transformation on item click to get the animation for going to that page. I added Jetpack navigation instead of launching fragments from the mainActivity. This implementation is cleaner and more lifecycle safe than the raw adding and replacing of fragments that we learned sucked over the years(Also safeArgs!!!!!).  I would replace Glide wth Coil but also needed to replace the TestModule that was there, which was really good. Coil is more kotlin friendly but Glide is faster and more supported so ths was trivial and I didn't remove it(For now). I never liked Dagger before because it was very intrusive to the app. The dependencies were too rooted into everything. I found out about Hilt a little bit ago and was intrigued how things had changed. I like this a lot more. I learned it for this project and think we will be moving to this over manual injection.(If just for the sake of the dreaded viewmodel factory. So much boilerplate. Also referring to my current job.) Also there is no toolbar but I left that alone for now as that wasn't important and there was not enough data to know what one would look like. Added a viewLifecycle extension for viewbinding. Helps with not having a null checked binding everywhere in the code. We recently found it's relatively unsafe with viewtree observers but that's on rare occasion and I'm sure can be fixed. I think compose will remove that issue anyway. I would have added Unit UI Test. This would have tested the fragment's ui for displaying the correct information. We would compare the values passed in to what is displayed on the screen through fragmentScenarios. This would launch all of our fragments and make sure their data matched and the ui looked accordingly. This can be ran in Firebase and prints out screenshots of failures. I lean towards this approach, for one because we aren't just testing data but also ui and because it helps test apis. So then it's testing actual api data and not mock data that is always perfect.
